// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  name  = Dominique COLLIN
//	mail  = dnilloc@sfr.fr
//	adress= 18 rue Joseph Cadei - 06100 , Nice - France.
//	Phone = 04.93.37.69.13  portable = 06.48.85.12.62.
//  Work  = Lyce Professionnel Pasteur
//				25 rue du Professeur Delvalle - 06000, Nice.
//	date  = 20 Dcembre 2010.- 11 08 2011 - Juillet 2012.
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Objet = Gnomonique thorique : la CATOPTRIQUE
// 	ETUDE d'un CADRAN SOLAIRE PLAN a REFLEXION
//
//	CAS du PVD (PLAN VERTICAL DECLINANT)
//	et du PID (PLAN INCLINE DECLINANT).
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Asymptote version 2.17svn-r5443 [(C) 2004 Andy Hammerlindl, John C. Bowman, Tom Prince]
//	version pour Macintosh Intel Snow Leopard (10.7.4).
//	Application Terminal version 2.2.3 (303.2)
//	Editeur de Texte = TexTMate version 1.5.11 (1635).
//  Aide sur ASYMPTOTE = http://marris.org/asymptote/index.html (site de Gatan MARRIS)
//	et aussi : http://www.piprime.fr/asymptote/ (site de Philippe IVALVI).
// ------------------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------------------
import geometry;
import labelpath;
import graph;
usepackage("relsize");
usepackage("inputenc","utf8");
usepackage("amsmath");
// --- LA FIGURE
size(12cm);
// ------------------------------------------------------------------------------------------------
// ******************** -------
// DECLARATION DES VARIABLES :|
// ******************** -------
// -------------------- Paramtres gomtriques :
real phi, Dm, Im, AH_n, dd_n, D, I , R ;
// ----------------- variables horaires et horizontales locales du rayon incident / rayon rflchi
real epsilon, dd, AH, hi, Azi, hr, Azr, AH_0, Az_0, AH_0c, AH_semidiurne, h_lever, Az_lever, h_coucher, Az_coucher ;
// -------------------- 
real Z, AH_init, AH_final ; 
// -------------------- angle incident, inclinaison du plan incident
real i, alpha_0 , alpha_1 ;
// -------------------- coordonnes de la tache de lumire
real T_Xasy, T_Yasy, T_X, T_Y, T_Z ;
// ------------------------------------------------------------ ------------------
// ******** VALEURS des PARAMETRES...***********************|
// ------------------------------------------------------------ ------------------
R = 1.5		;		// rayon de la sphre cleste = distance du plan du cadran au miroir...

phi = 43+42/60+50/3600 ; 			// latitude du lieu.
	
	Dm = 30 	;		// Dclinaison gnomonique du plan du Miroir.
 	Im = 20 		;		// Distance znithale de la normale au plan du Miroir.
	
	D = 180 	;		// Dclinaison gnomonique du cadran.
	I = 180	 	;		// Distance znithale de la normale au plan du cadran.

	epsilon = 23.44;//+26/60;
//
	real A = 2*R ;	// pour le rglage de la dimension gnrale de la figure

// ------------------------------------------------------------ ------------------
// CALCULS DE LA DECLINAISON ET ANGLE HORAIRE DU POINT NORMAL AU MIROIR...
// (AH_n ; dd_n) SONT LES CARACTERISTIQUES GEOMETRIQUES DE LA NORMALE AU MIROIR RAPPORTE AU PÔLE NORD CELESTE.
// ------------------------------------------------------------
// ----------------------- DECLINAISON DE LA NORMALE AU MIROIR.
// -----------------------
dd_n = aSin( Sin(phi)*Cos(Im) - Cos(phi)*Sin(Im)*Cos(Dm) ) ;
// ----------------------- ANGLE HORAIRE DE LA NORMALE AU MIROIR
// -----------------------
AH_n = aTan( Sin(Dm)/( Cos(phi)/Tan(Im) + Sin(phi)*Cos(Dm) ) );
	// extraction de l'angle avec arctan()...
	if( (Dm>0) & (AH_n<0)) {AH_n=AH_n+180;}
	if( (Dm<0) & (AH_n>0)) {AH_n=AH_n-180;}
real AH_n1 = 2*aTan( sqrt( (Cos(phi-dd_n)-Cos(Im)) / (Cos(Im) + Cos(phi+dd_n))) ) ;
	if( sgn(Dm)==sgn(AH_n1)) {AH_n1=AH_n1;} else {AH_n1=-AH_n1;}
	write("dd_n = ", dd_n);
	write("AH_n = ", AH_n);
	write("AH_n1 = ", AH_n1);
//
// fin des calculs des paramtres gomtriques du miroir.
// ------------------------------------------------------------ --------
// 	COORDONNEES Dans le Plan du CADRAN INCLINE DECLINANT |  P.I.D.
//	GY horizontal et vers la droite, GX vertical et vers le bas.
// ------------------------------------------------------------ --------

real m=-1;
for(m=-1;m<2;++m){// Trac par le calcul
		dd = epsilon*m ;
	// ---- LEVER SUR LE MIROIR
	AH_0 = AH_n - aCos(-Tan(dd_n)*Tan(dd)); // arc semi-diurne du lever relatif au miroir...
	// ---- COUCHER SUR LE MIROIR
	AH_0c = AH_n + aCos(-Tan(dd_n)*Tan(dd)) ;
	//////
	AH_semidiurne = aCos(-Tan(phi)*Tan(dd)); // coucher ou lever du soleil reel
///	
	if( AH_0 > -AH_semidiurne ) {AH_init=-Floor(abs(AH_0)/15)*15;}
		else {AH_init=-Floor(abs(AH_semidiurne)/15)*15;}
	if( AH_0c < AH_semidiurne ) {AH_final=Floor(AH_0c/15)*15;}
		else {AH_final=Floor(AH_semidiurne/15)*15;}
	//////
// Trac des arcs diurnes : solstice t, equinoxes, solstice d'hiver:
for(AH=AH_init;AH<=AH_final;++AH) {//	
// Hauteur et Azimut du Rayon incident (ou Soleil Incident) :
	hi  = aSin( Sin(phi)*Sin(dd)+Cos(phi)*Cos(dd)*Cos(AH) ); 	// hauteur du soleil
	Azi = aTan( Sin(AH)/(Sin(phi)*Cos(AH)-Cos(phi)*Tan(dd)) );  // azimut du soleil
	// extraction de l'angle avec arctan()...
		if((AH > 0) & (Azi<0)) {Azi=Azi+180;}
		if((AH < 0) & (Azi>0)) {Azi=Azi-180;}
//////angle incident i
	i = aCos( Cos(Im)*Sin(hi)+Sin(Im)*Cos(hi)*Cos(abs(Azi-Dm)) );
////// Hauteur hr et Azimut Azr du Rayon rflchi
	hr = aSin( Sin(2*Im)*Cos(hi)*Cos(Azi-Dm) + Cos(2*Im)*Sin(hi) ); // 
	Z=2*aTan( sqrt( (Cos(hr-hi)-Cos(2*i))/(Cos(2*i) + Cos(hi+hr)) ) );	
	if(Azi>Dm) {Azr = Azi - Z;} else {Azr = Azi + Z;}
////// CALCUL DE LA POSITION DE LA TACHE DE LUMIERE
	T_X = R*(Sin(I)*Tan(hr)-Cos(I)*Cos(Azr-D))/(Cos(I)*Tan(hr) + Sin(I)*Cos(Azr-D));
	T_Y = R*Sin(Azr-D)/(Cos(I)*Tan(hr) + Sin(I)*Cos(Azr-D));
	T_Z = 0; 
	if(abs(T_X)>A || abs(T_Y)>A) {exit;}// pour liminer les points trop loin du centre du repre...
		else { // si non, on fait le trac en tenant des axes sous asymptote :
			if(m==-1) {dot((T_Y,-T_X),blue+0.25mm);}	// pour l'hiver
			if(m==+1) {dot((T_Y,-T_X),orange+0.25mm);} 	// pour l't
			if(m==0)  {dot((T_Y,-T_X),black+0.25mm);}	// pour l'quinoxe
		}//fin if
}//fin for
}//fin for
//

// Trac des lignes horaires positifs (ou de l'Aprs-midi) :
for(AH=0;AH<=120;AH=AH+15) {//
for(dd=-epsilon;dd<=+epsilon;dd=dd+1/2) {//
	// ---- COUCHER SUR LE MIROIR
	AH_0c = AH_n + aCos(-Tan(dd_n)*Tan(dd)) ;
	//////
	AH_semidiurne = aCos(-Tan(phi)*Tan(dd)); // coucher ou lever du soleil reel
	//
	if( AH > AH_0c || AH > AH_semidiurne ) {exit;}
	else {//
	/////// ---- Hauteur et Azimut du Rayon incident (ou Soleil Incident) :
	hi  = aSin( Sin(phi)*Sin(dd)+Cos(phi)*Cos(dd)*Cos(AH) ); 	// hauteur du soleil
	Azi = aTan( Sin(AH)/(Sin(phi)*Cos(AH)-Cos(phi)*Tan(dd)) );  // azimut du soleil
	// extraction de l'angle avec arctan()...
		if((AH > 0) & (Azi<0)) {Azi=Azi+180;}
		if((AH < 0) & (Azi>0)) {Azi=Azi-180;}
////// angle incident i
	i = aCos( Cos(Im)*Sin(hi)+Sin(Im)*Cos(hi)*Cos(abs(Azi-Dm)) );
////// Hauteur hr et Azimut Azr du Rayon rflchi
	hr = aSin( Sin(2*Im)*Cos(hi)*Cos(Azi-Dm) + Cos(2*Im)*Sin(hi) ); // 
	Z=2*aTan( sqrt( (Cos(hr-hi)-Cos(2*i))/(Cos(2*i) + Cos(hi+hr)) ) );	
	if(Azi>Dm) {Azr = Azi - Z;} else {Azr = Azi + Z;}
////// CALCUL DE LA POSITION DE LA TACHE DE LUMIERE
	T_X = R*(Sin(I)*Tan(hr)-Cos(I)*Cos(Azr-D))/(Cos(I)*Tan(hr) + Sin(I)*Cos(Azr-D));
	T_Y = R*Sin(Azr-D)/(Cos(I)*Tan(hr) + Sin(I)*Cos(Azr-D));
	T_Z = 0; 
	pair T=(T_Y,-T_X);// Coordonnees de la tache lumineuse dans le plan du cadran (axes sous asymptote)
	if(abs(T_X)>A || abs(T_Y)>A) {exit;}// pour liminer les points trop loin du centre du repre...
		else { // on fait le trac:
			if(AH==0) {dot((T_Y,-T_X),red+0.3mm);}
			if(AH>0)  {dot((T_Y,-T_X),orange+0.25mm);}
			if(dd==-epsilon+0.5*80) {label(scale(0.5)*format("%f",AH/15+12),(T_Y,-T_X),0.25*E);}
		}//fin if
	}//fin if
//
}// fin for
}//fin for
//
// Trac des angles horaires ngatifs (ou du Matin) :
for(AH=-120;AH<0;AH=AH+15) {//
for(dd=-epsilon;dd<=+epsilon;dd=dd+1/2) {//
	// ---- LEVER SUR LE MIROIR
	AH_0 = AH_n - aCos(-Tan(dd_n)*Tan(dd)); // arc semi-diurne du lever relatif au miroir...
	//////
	AH_semidiurne = aCos(-Tan(phi)*Tan(dd)); // coucher ou lever du soleil reel
	//
	if( AH < AH_0 || AH < -AH_semidiurne ) {exit;}
	else {//
	/////// ---- Hauteur et Azimut du Rayon incident (ou Soleil Incident) :
	hi  = aSin( Sin(phi)*Sin(dd)+Cos(phi)*Cos(dd)*Cos(AH) ); 	// hauteur du soleil
	Azi = aTan( Sin(AH)/(Sin(phi)*Cos(AH)-Cos(phi)*Tan(dd)) );  // azimut du soleil
	// extraction de l'angle avec arctan()...
		if((AH > 0) & (Azi<0)) {Azi=Azi+180;}
		if((AH < 0) & (Azi>0)) {Azi=Azi-180;}
////// angle incident i
	i = aCos( Cos(Im)*Sin(hi)+Sin(Im)*Cos(hi)*Cos(abs(Azi-Dm)) );
////// Hauteur hr et Azimut Azr du Rayon rflchi
	hr = aSin( Sin(2*Im)*Cos(hi)*Cos(Azi-Dm) + Cos(2*Im)*Sin(hi) ); // 
	Z=2*aTan( sqrt( (Cos(hr-hi)-Cos(2*i))/(Cos(2*i) + Cos(hi+hr)) ) );	
	if(Azi>Dm) {Azr = Azi - Z;} else {Azr = Azi + Z;}
////// CALCUL DE LA POSITION DE LA TACHE DE LUMIERE
	T_X = R*(Sin(I)*Tan(hr)-Cos(I)*Cos(Azr-D))/(Cos(I)*Tan(hr) + Sin(I)*Cos(Azr-D));
	T_Y = R*Sin(Azr-D)/(Cos(I)*Tan(hr) + Sin(I)*Cos(Azr-D));
	T_Z = 0; 
	pair T=(T_Y,-T_X);// Coordonnees de la tache lumineuse dans le plan du cadran (axes sous asymptote)
	if(abs(T_X)>A || abs(T_Y)>A) {exit;}// pour liminer les points trop loin du centre du repre...
		else { // on fait le trac:
			dot((T_Y,-T_X),blue+0.25mm);
			if(dd==-epsilon+0.5*80) {label(scale(0.5)*format("%f",AH/15+12),(T_Y,-T_X),0.25*E);}
		}//fin if
	}//fin if
//
}// fin for
}//fin for
/*/
for(m=-1;m<=1;m=m+1/10){//trac de la ligne des couchers
	dd=m*epsilon;
	write("dd=",dd);write("m=",m);
	AH_0c = AH_n + aCos(-Tan(dd_n)*Tan(dd)); // arc semi-diurne du coucher relatif au miroir...
	AH_semidiurne = aCos(-Tan(phi)*Tan(dd)); // arc semi-diurne du coucher du soleil reel
	if( AH_0c <= AH_semidiurne ) {AH=AH_0c+1/10;}
		else {AH=AH_semidiurne+1/10;}
		write("AH=",AH);
// Hauteur et Azimut du Rayon incident (ou Soleil Incident) :
	hi  = aSin( Sin(phi)*Sin(dd)+Cos(phi)*Cos(dd)*Cos(AH) ); 	// hauteur du soleil
	Azi = aTan( Sin(AH)/(Sin(phi)*Cos(AH)-Cos(phi)*Tan(dd)) );  // azimut du soleil
	// extraction de l'angle avec arctan()...
		if((AH > 0) & (Azi<0)) {Azi=Azi+180;}
		if((AH < 0) & (Azi>0)) {Azi=Azi-180;}
//////angle incident i
	i = aCos( Cos(Im)*Sin(hi)+Sin(Im)*Cos(hi)*Cos(abs(Azi-Dm)) );
////// Hauteur hr et Azimut Azr du Rayon rflchi
	hr = aSin( Sin(2*Im)*Cos(hi)*Cos(Azi-Dm) + Cos(2*Im)*Sin(hi) ); // 
	Z=2*aTan( sqrt( (Cos(hr-hi)-Cos(2*i))/(Cos(2*i) + Cos(hi+hr)) ) );	
	if(Azi>Dm) {Azr = Azi - Z;} else {Azr = Azi + Z;}
////// CALCUL DE LA POSITION DE LA TACHE DE LUMIERE au coucher-1h.
	T_X = R*(Sin(I)*Tan(hr)-Cos(I)*Cos(Azr-D))/(Cos(I)*Tan(hr) + Sin(I)*Cos(Azr-D));
	T_Y = R*Sin(Azr-D)/(Cos(I)*Tan(hr) + Sin(I)*Cos(Azr-D));
	T_Z = 0; 
////// 
	dot((T_Y,-T_X),green+0.25mm); // point du lever  la premire heure pleine....
//
}// fin for
*/

// INCLINAISON DE LA LIGNE DE MIDI SUR LA LIGNE DE PLUS GRANDE PENTE DU CADRAN INCLINE DECLINANT
// --------- 
	real	P = (2*Sin(I)*Sin(Dm)*Tan(Im) + Cos(I)*(Sin(D)+Sin(D-2*Dm)*(Tan(Im))^2)),
			Q = (Cos(D)+Cos(D-2*Dm)*(Tan(Im)^2)) ;
	alpha_1 = aTan( P / Q );
	write("alpha = ",alpha_1);
	//draw(-A*dir(90+alpha_1)--A*dir(90+alpha_1),dashed+0.05mm+red);
// --------- Superbe formule... qui a demand quelques efforts pas ngligeables!

// ---------------- Dessin de la configuration mutuelle des DECLINAISONS du MIROIR et du PID
//
	// On dfinit...
	real r=1;
	pair Gr = r*dir(-D) , Mr = r/3*dir(90-Dm); // position des PID et MID
	pair Grn= 0.6*r*dir(-D),	Mrn=0.35*dir(180-Dm), sud = dir(180); // position des normales au PID et MID
	point B = A*dir(135); // position centrale de la figure du PID et MID dans la feuille gnrale.
//
	circle c = circle(B,r); // trace du plan horizontal avec la sphre cleste.
	circle c_bis = circle(B,r+.5*r); // cercle concentrique au prcdent
//
	draw(B,black+0.5mm);
	draw(shift(B)*(0.9*sud--1.2*sud),black+0.15mm,Arrow(1mm));// Direction du Sud
	label("{\relsize{-3}{Sud}}",shift(B)*(1.2*sud),N);
//
	draw(shift(B)*Gr,blue+1mm) ;
	draw(shift(B)*Mr--shift(B)*(-Mr),black+0.2mm);
	draw(c , dashed+red+0.1mm);
	//draw(c_bis , dashed+blue+0.1mm);
	draw(shift(B)*(Gr--Grn),blue+0.25mm,Arrow(1mm));		// trac de la normale horizontale du PID
	draw(shift(B)*((0,0)--Mrn),black+0.25mm,Arrow(1mm));	// trac de la normale horizontale du MID	
//
	line tgt = tangent(c,shift(B)*Gr);
	//draw(tgt,red);
	point[ ] J=intersectionpoints(tgt, c_bis);
	draw(J[0]--J[1], blue+0.5mm);
// ---------------	

	
// ---------------- Dessin des axes
//
// --- LES AXES
//xaxis(scale(3/4)*"$y$", Arrow);
//yaxis(scale(3/4)*"$x$", Arrow);
//labelx(scale(3/4)*"$y$",0.975A,N);
//labely(scale(3/4)*"$x$",-0.97A,E);
//
//draw((-A,0)--(A,0),Arrow());
draw((0,A)--(0,-A),Arrow());
//draw(Circle((0,0),A));
//
//
	xaxis(Label("$y$",position=EndPoint, align=NE),
	      xmin=-A, xmax=A+1,
	      Ticks(scale(.4)*Label(),
	            NoZero,
	            endlabel=true,   // ote le dernier label (5)
	            Step=1,step=.25,
	            end=true,   // ote la dernire graduation principale (celle de 5)
	            Size=.8mm, size=.4mm,
	            pTick=black,ptick=gray),
	            Arrow);

	yaxis(Label("$x$",position=(0,-A), align=NE),
	      ymin=-A,ymax=A,
	      Ticks(scale(.4)*Label(),
	            NoZero,
	            Step=1,step=.25,
	            end=true,   // ote la dernire graduation principale (celle de 5)Size=.8mm, size=.4mm,
	            Size=.8mm, size=.4mm,
	            pTick=black,ptick=gray)//, Arrow
				);