// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  name  = Dominique COLLIN
//	mail  = dnilloc@sfr.fr
//	adress= 18 rue Joseph Cadei - 06100 , Nice - France.
//	Phone = 04.93.37.69.13  portable = 06.48.85.12.62.
//  Work  = Lycée Professionnel Pasteur
//				25 rue du Professeur Delvalle - 06000, Nice.
//	date  = 11 08 2011 & Juillet 2012.
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Objet = Gnomonique théorique : la CATOPTRIQUE
// 	ETUDE d'un CADRAN SOLAIRE PLAN a REFLEXION
//
//	CAS du PVD (PLAN VERTICAL DECLINANT)
//	et du PID (PLAN INCLINE DECLINANT).
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Free Pascal Compiler version 2.6.0 [2011/12/30] for i386
//	version pour Macintosh Intel Snow Leopard (10.7.4).
//	XQuartz 2.7.2 (xorg-server 1.12.2) (X11 system)
//	Application Terminal version 2.2.3 (303.2)
//	Editeur de Texte = TexTMate version 1.5.11 (1635).
// ------------------------------------------------------------------------------------------------
program Catoptrique;
Uses Math;
// ------------------------------------------------------------
// Déclaration des Constantes.
// ------------------------------------------------------------
	const
		deupi = 6.2831853071795864;
		pi = 3.1415926535897932;
// ------------------------------------------------------------
// Fonctions trigonométriques.
// ------------------------------------------------------------
	function arcsin (x: extended): extended;
	begin
		arcsin := arctan(x / sqrt(1 - x*x)) * 180 / pi;
	end;
	function modu (x, y: extended): extended;
		var
			u: extended;
	begin
		u := x - trunc(x / y) * y;
		if u < 0 then
			modu := u + y
		else
			modu := u
	end;
	function tg (x: extended): extended;
	begin
		tg := (sin(x) / cos(x));
	end;
	function arcos (x: extended): extended;
	begin
		arcos := 90 + (arctan(-x / sqrt(1 - x*x)) * 180 / pi);
	end;	
// ------------------------------------------------------------
// Déclaration des Variables.
// ------------------------------------------------------------
	var	
		fichier: Text;
		fi, k, epsilon, lambda, ell: extended;
		Icad, Dcad, Dm, Im, dd_n, AH_n, AH_n1, AH_n2, n1: extended;
		j, ZZ, hs, az, azr, hr, q, pp, P, R, A: extended;
		X, Y, Z, Xa, Ya, x1, y1, z1: extended;
		dd, AH, AH1, AH_0: extended;
		i0n, i0d, i0: extended;
		AH_semidiurne, AH_0c, AH_ini, AH_fin: extended; 
	
		u: extended;
		v: integer;
//
// ------------------------------------------------------------
//	PVD = Plan Vertical Déclinant
//	PID = Plan Incliné Déclinant
//	MID = Miroir Incliné Déclinant
// ------------------------------------------------------------
//
begin

	k := pi / 180;
	
// ------------------------------------------------------------
// Paramètres du MID et du PID.
// ------------------------------------------------------------
{catoptrique - Le MID}

	R := 1.5 ;	 			{Rayon de la sphère céleste, et aussi distance orthogonale du MID au PID.
							L unité est le mètre.}
	A := 2.5*R;
	
	Dm := 20	;			// Déclinaison gnomonique du MID
	Im := 20	;			// Distance zénithale de la normale au miroir (MID)
	
{catoptrique - Le PID}

	Dcad := 150 ;			// Déclinaison gnomonique du cadran (PID)
	Icad := 155 ;			// Distance zénithale du PID
	
	fi :=  43+43/60+0/3600 ;				// Latitude du lieu du PID

	epsilon := 23+26/60 ;	// Obliquité de l'écliptique
	
	// Coordonnées du point tangent G du PID avec la Sphère Céleste
	ell := -Dcad ;
	lambda := +Icad ;
	
{catoptrique - Caractéristiques de la normale au MID}

// -------------------- DECLINAISON EQUATORIALE DE LA NORMALE AU MIROIR.
	dd_n := sin(fi*k)*cos(Im*k) - cos(fi*k)*sin(Im*k)*cos(Dm*k) ;
	dd_n := arcsin( dd_n) ;
	
// -------------------- ANGLE HORAIRE DE LA NORMALE AU MIROIR
	AH_n := sin(Dm*k)/( cos(fi*k)/tg(Im*k) + sin(fi*k)*cos(Dm*k) );
	AH_n := arctan( AH_n) / k ;
		// extraction de l'angle avec arctan()...
		if (Dm>0) and (AH_n<0) then  AH_n := AH_n+180;
		if (Dm<0) and (AH_n>0) then  AH_n := AH_n-180;

	// 2eme formule possible:
	n1 := ( cos((fi-dd_n)*k) - cos(Im*k) )/( cos(Im*k) + cos((fi+dd_n)*k) );
	AH_n1 := 2*arctan (sqrt(n1) ) / k ;
	// test car AH_n doit être du même signe que Dm
	if (Dm > 0) then AH_n1 := AH_n1  else AH_n1 := - AH_n1 ; 
	
	// 3eme formule possible:
	AH_n2 := arcsin( sin(Dm*k)*sin(Im*k)/cos(dd_n*k));
		// attention l'extraction n'est pas sûre dès que AH_n dépasse les +/- 90

{fin catoptrique}
// ---------------------------------------------------------------------------------

{Cadran solaire incliné déclinant à réflexion}
// ----------------------------------------------------------------------------
// CALCUL DES POSITIONS DE LA TACHE LUMINEUSE OBTENUE PAR REFLEXION SUR UN MID.
// ----------------------------------------------------------------------------
//writeln(fichier,'%   ', 'X ', '         ',  'Y ', '         ', 'Z ', '          ', 'H ', '      ', 'dd');
Assign(fichier,'arc-diurnes.dat');	
ReWrite(fichier);
////// TRACEE DES ARCS DIURNES :
for v:=-1 to 1 do 
begin
	if v=-1 then
	begin
		writeln(fichier, '% SOLSTICE HIVER'); // pour TikZ / GnuPlot / LaTeX
		writeln(fichier, '%'); 
	end;
	if v=1 then
	begin
		writeln(fichier, '% SOLSTICE ETE'); // pour TikZ / GnuPlot / LaTeX 
		writeln(fichier, '%'); 
	end;
	if v=0 then
	begin
		writeln(fichier, '% EQUINOXES'); // pour TikZ / GnuPlot / LaTeX 
		writeln(fichier, '%'); 
	end;
//
	dd := v*epsilon;// delta fixé à chaque boucle
	AH_0 := AH_n - arcos(-tg(dd_n*k)*tg(dd*k)); // arc semi-diurne du lever relatif au miroir...
	AH_0c := AH_n + arcos(-tg(dd_n*k)*tg(dd*k)) ; // arc semi-diurne du coucher sur le miroir...
	AH_semidiurne := arcos(-tg(fi*k)*tg(dd*k)); // arc semi-diurne du coucher ou lever du soleil reel
	///	calcul des AH initiaux et finaux pour chaque incrément m
	if AH_0 > -AH_semidiurne then AH_ini:=-floor(abs(AH_0)/15)*15 
		else AH_ini:=-floor(abs(AH_semidiurne)/15)*15;
	if AH_0c < AH_semidiurne then AH_fin:=Floor(AH_0c/15)*15     
		else AH_fin:=floor(AH_semidiurne/15)*15;
	//
	u:=AH_ini;
	while u<=AH_fin do
	begin		
		AH := u;			
	// EN COORDONNÉES HORIZONTALES...
	// ------ Soleil Incident : (hs; az) ----------------------------------------	
		hs := sin(fi*k) * sin(dd*k) + cos(fi*k) * cos(dd*k) * cos(AH*k);
		hs := arcsin(hs); // hauteur du soleil incident

		az := sin(AH*k) / (sin(fi*k) * cos(AH*k) - cos(fi*k) * tg(dd*k));
		az := arctan(az) / k;
			// extraction de l'azimut du soleil incident avec arctan()...
		if (AH > 0) and (az < 0) then	az := az + 180;
		if (AH < 0) and (az > 0) then	az := az - 180;
	// ----- Angle incident  (i) ------------------------------------------------
		j := cos(Im*k)*sin(hs*k) + sin(Im*k)*cos(hs*k)*cos(abs(az-Dm)*k);
		j := arcos(j); // angle d'incidence
	// ------ Soleil Réfléchi  (hr; azr)-----------------------------------------
		hr := sin(2*Im*k)*cos(hs*k)*cos(abs(az-Dm)*k) + cos(2*Im*k)*sin(hs*k);
		hr := arcsin(hr); // hauteur du soleil réfléchi

		q := ( cos((hr-hs)*k) - cos(2*j*k) ) / (  cos(2*j*k) + cos((hr+hs)*k) );
		if (q>0) then ZZ := sqrt( q );
		ZZ := 2 * arctan(ZZ) / k;
		// azimut du soleil réfléchi
		if (az > Dm) then 	azr := az - ZZ	else	 azr := az + ZZ;
// ---------------------------------------------------------------------------------
	// COORDONNEES DE LA TACHE LUMINEUSE DANS LE PID -- Usage des Coordonnées horizontales locales.
	// Lorsque l'Observateur regarde le PID : 
	// 	X=axe vertical vers le bas ,
	//	Y=axe Horizontal Vers la droite ,
	//	Z=axe normal au cadran et dirigé vers le centre O du MID.

		X := R*( sin(Icad*k)*tg(hr*k) - cos(Icad*k)*cos((azr-Dcad)*k) ) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) );  
		Y := R * sin((azr-Dcad)*k) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) ); 
		Z := 0 ;
		// Pour des axes imposés par les logiciels de tracé (OXYZ mathématique): 
		Xa:=Y;
		Ya:=-X;
		// Z reste inchangé...
	// -----------
	// Changement de coordonnées pour le PID : repère local (3D) Oxyz tel que :
	// 	Ox=Sud,
	//	Oy=Est
	//	Oz=zénith.
	//  conversion pour CurvusPro
		x1 := cos(lambda*k)*cos(ell*k)*X - Y*sin(ell*k) + Z*sin(lambda*k)*cos(ell*k) - R*sin(lambda*k)*cos(ell*k) ;
		y1 := cos(lambda*k)*sin(ell*k)*X + Y*cos(ell*k) + Z*sin(lambda*k)*sin(ell*k) - R*sin(lambda*k)*sin(ell*k) ;
		z1 := -sin(lambda*k)*X           + Y*0          + Z*cos(lambda*k)            - R*cos(lambda*k) ;
// --------------------------------------------------------------------------------
	// ------ Résultats ---------------------------------------------
	//	writeln(fichier, Xa:1:5, '    ', Ya:1:5,'    ', Z:1:5, '    ', AH:1:1,'    ', dd:1:3);
	if abs(Xa) < A then writeln(fichier, Xa:1:5,'  ', Ya:1:5, '   ', Z:1:0); // 2D pour TikZ / GnuPlot / LaTeX / Grapher
	//writeln(fichier, Xa:1:5, '    ', Ya:1:5, '       ', Z:1:0); // 3D pour GRAPHER
	//writeln(x1 : 1 : 5, '  ',y1:1:5,'  ', z1 : 1 : 5, ' ',AH : 1 : 2);

	u:=u+15/60;	
	end;// fin while
	//
end;// fin for	
Close(fichier);
/////////////////////////////// Tracé des lignes horaires
Assign(fichier,'heures.dat');	
ReWrite(fichier);
// Tracé des lignes horaires positifs (ou de l'Après-midi) :
AH:=15; // initialisation
//
while AH<=120 do //
begin
dd:=epsilon; // initialisation
writeln(fichier, '% Angle Horaire apres-midi = ', AH:1:1); //
writeln(fichier, '%'); //
while dd >= -epsilon do //
begin
	////
	AH_0c := AH_n + arcos(-tg(dd_n*k)*tg(dd*k)) ; // arc semi-diurne du coucher sur le miroir...
	AH_semidiurne := arcos(-tg(fi*k)*tg(dd*k)); // arc semi-diurne du coucher ou lever du soleil reel
	if AH_0c < AH_semidiurne then AH_fin:=floor(AH_0c/15)*15     
		else AH_fin:=floor(AH_semidiurne/15)*15;
	if AH > AH_fin then break;
	////
	// ------ Soleil Incident : (hs; az) ----------------------------------------	
		hs := sin(fi*k) * sin(dd*k) + cos(fi*k) * cos(dd*k) * cos(AH*k);
		hs := arcsin(hs); // hauteur du soleil incident

		az := sin(AH*k) / (sin(fi*k) * cos(AH*k) - cos(fi*k) * tg(dd*k));
		az := arctan(az) / k;
			// extraction de l'azimut du soleil incident avec arctan()...
		if (AH > 0) and (az < 0) then	az := az + 180;
		if (AH < 0) and (az > 0) then	az := az - 180;
	// ----- Angle incident  (i) ------------------------------------------------
		j := cos(Im*k)*sin(hs*k) + sin(Im*k)*cos(hs*k)*cos(abs(az-Dm)*k);
		j := arcos(j); // angle d'incidence
	// ------ Soleil Réfléchi  (hr; azr)-----------------------------------------
		hr := sin(2*Im*k)*cos(hs*k)*cos(abs(az-Dm)*k) + cos(2*Im*k)*sin(hs*k);
		hr := arcsin(hr); // hauteur du soleil réfléchi
		q := ( cos((hr-hs)*k) - cos(2*j*k) ) / (  cos(2*j*k) + cos((hr+hs)*k) );
		if (q>0) then ZZ := sqrt( q );
		ZZ := 2 * arctan(ZZ) / k;
		// azimut du soleil réfléchi
		if (az > Dm) then 	azr := az - ZZ	else	 azr := az + ZZ;
	// COORDONNEES DE LA TACHE LUMINEUSE DANS LE PID -- Usage des Coordonnées horizontales locales.
		X := R*( sin(Icad*k)*tg(hr*k) - cos(Icad*k)*cos((azr-Dcad)*k) ) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) );  
		Y := R * sin((azr-Dcad)*k) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) ); 
		Z := 0 ;
		// Pour des axes imposés par les logiciels de tracé (OXYZ mathématique): 
		Xa:=Y;
		Ya:=-X;
		// Z reste inchangé...
		//
		if abs(Xa) <= A then writeln(fichier, Xa:1:5, '  ', Ya:1:5, '   ', Z:1:0); // pour TikZ / GnuPlot / LaTeX /Grapher
//
dd := dd - 1/10;
end; // pour la boucle for pour dd
writeln(fichier, ' '); //
AH := AH + 15;
end; // pour la boucle for pour AH
//
// Tracé des lignes horaires négatifs (ou de l'Après-midi) :
AH:=-120; // initialisation
//
while AH < 0 do //
begin
writeln(fichier, '% Angle Horaire du matin = ', AH:1:1); //
writeln(fichier, '%'); //
dd:=epsilon; // initialisation
while dd >= -epsilon do //
begin
	////
	AH_0 := AH_n - arcos(-tg(dd_n*k)*tg(dd*k)) ; // arc semi-diurne du lever sur le miroir...
	AH_semidiurne := arcos(-tg(fi*k)*tg(dd*k)); // arc semi-diurne du lever du soleil reel
	if AH_0 > -AH_semidiurne then AH_ini:=-floor(-AH_0/15)*15     
		else AH_ini:=-floor(AH_semidiurne/15)*15;
	if AH < AH_ini then break;
	////
	// ------ Soleil Incident : (hs; az) ----------------------------------------	
		hs := sin(fi*k) * sin(dd*k) + cos(fi*k) * cos(dd*k) * cos(AH*k);
		hs := arcsin(hs); // hauteur du soleil incident

		az := sin(AH*k) / (sin(fi*k) * cos(AH*k) - cos(fi*k) * tg(dd*k));
		az := arctan(az) / k;
			// extraction de l'azimut du soleil incident avec arctan()...
		if (AH > 0) and (az < 0) then	az := az + 180;
		if (AH < 0) and (az > 0) then	az := az - 180;
	// ----- Angle incident  (i) ------------------------------------------------
		j := cos(Im*k)*sin(hs*k) + sin(Im*k)*cos(hs*k)*cos(abs(az-Dm)*k);
		j := arcos(j); // angle d'incidence
	// ------ Soleil Réfléchi  (hr; azr)-----------------------------------------
		hr := sin(2*Im*k)*cos(hs*k)*cos(abs(az-Dm)*k) + cos(2*Im*k)*sin(hs*k);
		hr := arcsin(hr); // hauteur du soleil réfléchi
		q := ( cos((hr-hs)*k) - cos(2*j*k) ) / (  cos(2*j*k) + cos((hr+hs)*k) );
		if (q>0) then ZZ := sqrt( q );
		ZZ := 2 * arctan(ZZ) / k;
		// azimut du soleil réfléchi
		if (az > Dm) then 	azr := az - ZZ	else	 azr := az + ZZ;
	// COORDONNEES DE LA TACHE LUMINEUSE DANS LE PID -- Usage des Coordonnées horizontales locales.
		X := R*( sin(Icad*k)*tg(hr*k) - cos(Icad*k)*cos((azr-Dcad)*k) ) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) );  
		Y := R * sin((azr-Dcad)*k) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) ); 
		Z := 0 ;
		// Pour des axes imposés par les logiciels de tracé (OXYZ mathématique): 
		Xa:=Y;
		Ya:=-X;
		// Z reste inchangé...
		//
		if abs(Xa) <= A then writeln(fichier, Xa:1:5, '  ', Ya:1:5, '   ', Z:1:0); // pour TikZ / GnuPlot / LaTeX /Grapher
//
dd := dd - 1/10;
end; // pour la boucle for pour dd
//
writeln(fichier, ' '); //
AH := AH + 15;
end; // pour la boucle for pour AH
Close(fichier);
//
Assign(fichier,'midi.dat');	
ReWrite(fichier);
//
writeln(fichier, '% Ligne horaire de midi = ', AH:1:1); //
writeln(fichier, '%'); //
//
AH:=0;
dd:=epsilon; // initialisation
while dd >= -epsilon do //
begin
	////
	// ------ Soleil Incident : (hs; az) ----------------------------------------	
		hs := sin(fi*k) * sin(dd*k) + cos(fi*k) * cos(dd*k) * cos(AH*k);
		hs := arcsin(hs); // hauteur du soleil incident

		az := sin(AH*k) / (sin(fi*k) * cos(AH*k) - cos(fi*k) * tg(dd*k));
		az := arctan(az) / k;
			// extraction de l'azimut du soleil incident avec arctan()...
		if (AH > 0) and (az < 0) then	az := az + 180;
		if (AH < 0) and (az > 0) then	az := az - 180;
	// ----- Angle incident  (i) ------------------------------------------------
		j := cos(Im*k)*sin(hs*k) + sin(Im*k)*cos(hs*k)*cos(abs(az-Dm)*k);
		j := arcos(j); // angle d'incidence
	// ------ Soleil Réfléchi  (hr; azr)-----------------------------------------
		hr := sin(2*Im*k)*cos(hs*k)*cos(abs(az-Dm)*k) + cos(2*Im*k)*sin(hs*k);
		hr := arcsin(hr); // hauteur du soleil réfléchi
		q := ( cos((hr-hs)*k) - cos(2*j*k) ) / (  cos(2*j*k) + cos((hr+hs)*k) );
		if (q>0) then ZZ := sqrt( q );
		ZZ := 2 * arctan(ZZ) / k;
		// azimut du soleil réfléchi
		if (az > Dm) then 	azr := az - ZZ	else	 azr := az + ZZ;
	// COORDONNEES DE LA TACHE LUMINEUSE DANS LE PID -- Usage des Coordonnées horizontales locales.
		X := R*( sin(Icad*k)*tg(hr*k) - cos(Icad*k)*cos((azr-Dcad)*k) ) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) );  
		Y := R * sin((azr-Dcad)*k) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) ); 
		Z := 0 ;
		// Pour des axes imposés par les logiciels de tracé (OXYZ mathématique): 
		Xa:=Y;
		Ya:=-X;
		// Z reste inchangé...
		//
		if abs(Xa) <= A then writeln(fichier, Xa:1:5, '  ', Ya:1:5, '   ', Z:1:0); // pour TikZ / GnuPlot / LaTeX /Grapher
//
dd := dd - 1/10;
end; // pour la boucle for pour dd
Close(fichier);


/////////////////////////////// pour le répérage des lignes horaires en vue d'un marquage sous TikZ/pgfplots
Assign(fichier,'marquage.dat');	
ReWrite(fichier);
// Tracé des lignes horaires positifs (ou de l'Après-midi) :
AH:=-120; // initialisation
dd:=-epsilon+0.5*80; // déclinaison du soleil fixe - peut être ajusté manuellement
//
AH_0 := AH_n - arcos(-tg(dd_n*k)*tg(dd*k)) ; // arc semi-diurne du lever sur le miroir...
AH_0c := AH_n + arcos(-tg(dd_n*k)*tg(dd*k)) ; // arc semi-diurne du coucher sur le miroir...
AH_semidiurne := arcos(-tg(fi*k)*tg(dd*k)); // arc semi-diurne du coucher ou lever du soleil reel
if AH_0 > -AH_semidiurne then AH_ini:=-floor(-AH_0/15)*15     
	else AH_ini:=-floor(AH_semidiurne/15)*15;
if AH_0c < AH_semidiurne then AH_fin:=floor(AH_0c/15)*15     
	else AH_fin:=floor(AH_semidiurne/15)*15;
write('AH_ini = ',AH_ini:1:2); write('AH_fin = ',AH_fin:1:1);
//

while AH<=120 do //
begin
writeln(fichier, '% marquage heure pleine = ', AH:1:1); //
writeln(fichier, '%'); //
	////
	// ------ Soleil Incident : (hs; az) ----------------------------------------	
		hs := sin(fi*k) * sin(dd*k) + cos(fi*k) * cos(dd*k) * cos(AH*k);
		hs := arcsin(hs); // hauteur du soleil incident

		az := sin(AH*k) / (sin(fi*k) * cos(AH*k) - cos(fi*k) * tg(dd*k));
		az := arctan(az) / k;
			// extraction de l'azimut du soleil incident avec arctan()...
		if (AH > 0) and (az < 0) then	az := az + 180;
		if (AH < 0) and (az > 0) then	az := az - 180;
	// ----- Angle incident  (i) ------------------------------------------------
		j := cos(Im*k)*sin(hs*k) + sin(Im*k)*cos(hs*k)*cos(abs(az-Dm)*k);
		j := arcos(j); // angle d'incidence
	// ------ Soleil Réfléchi  (hr; azr)-----------------------------------------
		hr := sin(2*Im*k)*cos(hs*k)*cos(abs(az-Dm)*k) + cos(2*Im*k)*sin(hs*k);
		hr := arcsin(hr); // hauteur du soleil réfléchi
		q := ( cos((hr-hs)*k) - cos(2*j*k) ) / (  cos(2*j*k) + cos((hr+hs)*k) );
		if (q>0) then ZZ := sqrt( q );
		ZZ := 2 * arctan(ZZ) / k;
		// azimut du soleil réfléchi
		if (az > Dm) then 	azr := az - ZZ	else	 azr := az + ZZ;
	// COORDONNEES DE LA TACHE LUMINEUSE DANS LE PID -- Usage des Coordonnées horizontales locales.
		X := R*( sin(Icad*k)*tg(hr*k) - cos(Icad*k)*cos((azr-Dcad)*k) ) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) );  
		Y := R * sin((azr-Dcad)*k) / ( cos(Icad*k)*tg(hr*k) + sin(Icad*k)*cos((azr-Dcad)*k) ); 
		Z := 0 ;
		// Pour des axes imposés par les logiciels de tracé (OXYZ mathématique): 
		Xa:=Y;
		Ya:=-X;
		// Z reste inchangé...
		//
		if AH > 0 then if AH <= AH_fin then 
		if abs(Xa) < A then begin 
		AH1:=AH/15+12;
		writeln(fichier, AH1:1:0,'   ', Xa:1:5, '  ', Ya:1:5, '   ', Z:1:0); // pour TikZ / GnuPlot / LaTeX /Grapher
		end;
		if AH <= 0 then if AH >= AH_ini then
		if abs(Xa) < A then begin
		AH1:=AH/15+12;
		writeln(fichier, AH1:1:0,'   ', Xa:1:5, '  ', Ya:1:5, '   ', Z:1:0); // pour TikZ / GnuPlot / LaTeX /Grapher
		end;
//
writeln(fichier, ' '); //
AH := AH + 15;
end;
Close(fichier);

// -------------------------------------------------------------
// Inclinaison de la ligne de midi sur la LPGP (GX) -----
// -------------------------------------------------------------

	i0n := 2*sin(Icad*k)*sin(Dm*k)*tg(Im*k) + cos(Icad*k)*( sin((Dcad-2*Dm)*k)*tg(Im*k)*tg(Im*k) + sin(Dcad*k) ) ;
	i0d := cos((Dcad-2*Dm)*k)*tg(Im*k)*tg(Im*k) + cos(Dcad*k) ;
	i0  := arctan(i0n/i0d) / k ;

writeln('Inclinaison de la ligne de midi = ',i0:1:5 );

// -------------------------------------------------------------
{//
writeln('MID : [ Im = ', Im:1:1,' // ', 'Dm = ', Dm:1:1, '] ');
writeln('PID : [ Dcad = ', Dcad:1:1,' // ', 'Icad = ', Icad:1:1,' // ', 'R= ', R:1:2, '] ', '[ Latitude = ', fi:1:5, ' ]');
writeln('[ dd_n=', dd_n:1:5,' \\ ', 'AH_n = ', AH_n:1:5, ']');

writeln;

writeln('SOLEIL INCIDENT : [ dd =', dd:1:3,' // ', 'AH = ', AH:1:3, ']' );
writeln('angle incident i= ',j:1:5);
writeln('2e formule i= ',j2:1:5);
writeln('SOLEIL INCIDENT : [ hs =', hs:1:5,' // ', 'az =', az:1:5, ']' );

writeln;

writeln('SOLEIL REFLECHI : [ hr=', hr:1:5, ' // ','azr=', azr:1:5, ']' );
writeln('SOLEIL REFLECHI : [ dd_r = ',dd_r:1:5, ' // ', 'AH_r = ',AH_r:1:5,']' );

writeln;
}//
// -------------------------------------------------------------
end.